#load'C:\Users\Keith\Documents\ShopProjects\Misc Plugins\New_Part1.rb'
#NewPart1 Makes only the Assembly Layer

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------------
require 'sketchup.rb'

def create_new_part
  model = Sketchup.active_model
  entities = model.entities
  selection = model.selection
  layers = model.layers
  
 #This Section Provides the Layer No Input as Text
  
  @@layerno="01"  #Provides Starting No for New Dwg
  length = layers.length
  if length >1
    lname=nil
    i=0
    loop do
      i += 1
      break if i==length
      layer2 = layers[length-i]
      lname = layer2.name
      break if lname[0,1]=="A" and lname[3,1]=="-"  
    end
    name_no=lname[1,2].to_i
    next_name_no=(name_no+1).to_s
    if next_name_no.length < 2 
      @@layerno="0"+next_name_no
    else
      @@layerno=(name_no+1).to_s
    end
  end
  #--------------------------------------


  # Input Box and default data
    prompts = [$exStrings.GetString("Length"), $exStrings.GetString("Width"), $exStrings.GetString("Thickness"),$exStrings.GetString("Name"),$exStrings.GetString("layerno")]
    values = [10.inch, 4.inch, 0.75.inch,"Test",@@layerno]
    
    
    # Now display the inputbox
    results = inputbox prompts, values, $exStrings.GetString("Box Dimensions")
    
    return if not results # This means that the user canceld the operation
    
    length, width, thickness, name, @@layerno = results
    
    #This Section adds leading "0" if missing
    if @@layerno.length < 2 
      layerno="0"+@@layerno
    else
      layerno=@@layerno
    end
  #-----------------------------------------
    
   # Create new layer for Part Assembly
   
      newname = "A" + layerno + "-" + name
      if layers[newname]
	      UI.messagebox("Layer \"#{newname}\" exists, exiting.")
	    return
      end
      layer = layers.add newname
      pb = layer.page_behavior = LAYER_IS_HIDDEN_ON_NEW_PAGES
      model.pages.each { |p| p.set_visibility( layer, false ) }
    #-----------------------------------------------------------  
            
  #Create New Part Component
          
    model.start_operation $exStrings.GetString("Create Box")    
    entities = model.active_entities
    group = entities.add_group
    group.layer = layer
    entities = group.entities
      
    pts = []
    pts[0] = [0, 0, 0]
    pts[1] = [length, 0, 0]
    pts[2] = [length, thickness, 0]
    pts[3] = [0, thickness, 0]
    base = entities.add_face pts
    
    width = -width if( base.normal.dot(Z_AXIS) < 0 )
    
    # Now we can do the pushpull
    base.pushpull width

    # Now we are done and we can end the operation
    model.commit_operation
    
    # Convert the Group to a Component 
    component_instance=group.to_component  
    component_instance.definition.name=name
    model.commit_operation      
  #---------------------------------------
  
  # Make New Part Component visible on "Assembly" Page
   
     pages = model.pages
     page = pages["Assembly"]
     page.set_visibility(layers [newname] ,true) 
  #----------------------------------------------  
         
end 
    
if( not file_loaded?("New_Part1.rb") )

   UI.menu("Draw").add_item("New Part"){create_new_part}
 end


file_loaded("New_Part1.rb")
